package com.gzlh.config.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

@NoArgsConstructor
@Data
public class ApplicationConfigDTO implements Serializable {

    @JsonProperty("config")
    private ConfigDTO config;

    @NoArgsConstructor
    @Data
    public static class ConfigDTO {
        @JsonProperty("configList")
        private ConfigListDTO sysConfig;
        @JsonProperty("eventList")
        private EventListDTO eventList;
        @NoArgsConstructor
        @Data
        public static class EventListDTO {
            @JsonProperty("event")
            private List<EventDTO> event;
        }

        @Data
        @NoArgsConstructor
        public static class ConfigListDTO{
            @JsonProperty("serialSetting")
            private SerialSetting serialSetting;
        }
    }
}
