package com.gzlh.device.camera.client;

import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ChannelHandler.Sharable
public class CameraClientHandler extends SimpleChannelInboundHandler<String> {

    private CameraNettyConfig cameraNettyConfig;

    public CameraClientHandler(CameraNettyConfig cameraNettyConfig) {
        this.cameraNettyConfig = cameraNettyConfig;
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
        log.info("Camera 客户端收到消息：" + msg);

    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        log.error("Camera 客户端 连接断开，进行重连");
        cameraNettyConfig.connect();
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();
    }

}

