package com.gzlh.device.camera.controller;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.XmlUtil;
import com.gzlh.bus.EventDataManager;
import com.gzlh.config.SystemObject;
import com.gzlh.device.camera.factory.CameraFactory;
import com.gzlh.device.camera.properties.CameraPropertiesConfig;
import com.gzlh.utils.FileUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.web.ServerProperties;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import javax.annotation.Resource;
import java.io.IOException;
import java.net.InetAddress;
import java.util.*;


@RestController
@RequestMapping("/camera")
public class CameraController {
    @Resource
    private CameraFactory cameraFactory;
    @Resource
    private CameraPropertiesConfig cameraPropertiesConfig;
    @Resource
    private ServerProperties serverProperties;

    @PostMapping("/recv")
    public void recv(
            @RequestBody String xmlStr
//            HttpServletRequest request
    ) throws IOException {
//        String xmlStr = IOUtils.toString(request.getInputStream(), request.getCharacterEncoding());
        String path=SystemObject.filePropertiesConfig.getRootPath();
        String channelCode=SystemObject.applicationConfig.getChannelCode();
        Map<String, Object> StringObjectMap = new HashMap<>();
        Document document = XmlUtil.parseXml(xmlStr);
        Element rootElement = XmlUtil.getRootElement(document);
        String i_e_type = rootElement.getAttribute("I_E_TYPE");
        XmlUtil.xmlToMap(xmlStr, StringObjectMap);

        Map<String, Object> ic = BeanUtil.beanToMap(StringObjectMap.get("IC"));
        Map<String, Object> weight =BeanUtil.beanToMap(StringObjectMap.get("WEIGHT"));
        Map<String, Object> car = BeanUtil.beanToMap(StringObjectMap.get("CAR"));
        Map<String, Object> conta =BeanUtil.beanToMap(StringObjectMap.get("CONTA"));
        Map<String, Object> seal = BeanUtil.beanToMap(StringObjectMap.get("SEAL"));


        Map<String, String> boxNoMap = new HashMap<>();
//        cacheMap.put("carEcNo", (String) car.get("CAR_EC_NO"));
        boxNoMap.put("boxNoF", !StringUtils.isEmpty((String) conta.get("CONTA_ID_F"))?(String) conta.get("CONTA_ID_F"):"");
        boxNoMap.put("boxNoB", !StringUtils.isEmpty((String) conta.get("CONTA_ID_B"))?(String) conta.get("CONTA_ID_B"):"");

        EventDataManager.cacheData("boxNoList",boxNoMap);

        Calendar calendar = Calendar.getInstance();
        String ipAddr =InetAddress.getLocalHost().getHostAddress()+":"+String.valueOf(serverProperties.getPort());

        String savePath=path+"/"+channelCode+"/"+ calendar.get(Calendar.YEAR)+(calendar.get(Calendar.MONTH)+1)+calendar.get(Calendar.DAY_OF_MONTH);
        List<String> fList = new ArrayList();
        List<String> bList = new ArrayList();
        for (Map.Entry<String, Object> entry : conta.entrySet()) {
            if(entry.getKey().contains("PIC")&& !StringUtils.isEmpty((String) entry.getValue())){
                String filePath = FileUtils.downLoad((String) entry.getValue(),savePath);
                filePath=filePath.replace(path,ipAddr+"/files");
//                String base64 = FileUtils.getBase64FromImg(filePath);
                if (entry.getKey().contains("CONTA_F")){
                    fList.add(filePath);
                }else if (entry.getKey().contains("CONTA_B")){
                    bList.add(filePath);
                }
            }
        }
        EventDataManager.cacheData("boxFImgList",fList);
        EventDataManager.cacheData("boxBImgList",bList);


    }
}
