package com.gzlh.device.capture.factory;



import com.gzlh.device.capture.handler.ICaptureHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class CaptureFactory {
    @Autowired
    private List<ICaptureHandler>handlers;

    public ICaptureHandler handler(int code){
       return handlers.stream().filter(h->h.brandType().getCode()==code)
                .findAny().orElseThrow(()->new IllegalArgumentException("不支持相机"));
    }

}
