package com.gzlh.device.capture.task;

import cn.hutool.core.codec.Base64;
import cn.hutool.extra.spring.SpringUtil;

import com.gzlh.device.capture.event.CaptureEvent;
import com.gzlh.device.capture.factory.CaptureFactory;
import com.gzlh.device.capture.properties.CapturePropertiesConfig;
import com.gzlh.config.ModuleEnum;
import com.gzlh.bus.EventBus;
import com.gzlh.bus.EventDataManager;
import com.gzlh.config.task.Task;
import lombok.extern.slf4j.Slf4j;

import java.io.File;

/***
 * 将本地的车牌图片、车牌号缓存到数据中心
 */
@Slf4j
public class HandlerCarImage extends Task {
    private CaptureFactory captureFactory=SpringUtil.getBean(CaptureFactory.class);
    CapturePropertiesConfig capturePropertiesConfig=SpringUtil.getBean(CapturePropertiesConfig.class);
    private String filePath;
    private String carNo;
    public HandlerCarImage(String id, long delayInMilliseconds, String filePath, String carNo) {
        super(id, delayInMilliseconds);
        this.filePath=filePath;
        this.carNo=carNo;
    }

    @Override
    public void run() {
//      String base64=  Base64.encode(new File(filePath));
        EventDataManager.cacheData("carImg",filePath);
        EventDataManager.cacheData("carNo",carNo);
        EventBus eventBus=SpringUtil.getBean(EventBus.class);
        //向总线发送抓拍到车牌事件
        eventBus.startEvent(ModuleEnum.CAPTURE_MODULE.getModuleEn()+"."+ CaptureEvent.CAPTURE_CAR_NO);
    }
}
