package com.gzlh.device.electron.client;

import cn.hutool.core.util.StrUtil;
import com.gzlh.bus.EventConfig;
import com.gzlh.config.SystemObject;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ChannelHandler.Sharable
public class ElectronClientHandler extends SimpleChannelInboundHandler<String> {

    private ElectronNettyConfig electronNettyConfig;

    public ElectronClientHandler(ElectronNettyConfig electronNettyConfig) {
        this.electronNettyConfig = electronNettyConfig;
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
        if (StrUtil.isEmpty(msg)){
            return;
        }
        log.info("电子车牌 客户端收到消息：" + msg);
        SystemObject.electronFactory.handler(EventConfig.serialSetting.getElectron().getBrand())
                .handlerMsg(msg.toUpperCase());
    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        log.error("电子车牌 客户端 连接断开，进行重连");
        electronNettyConfig.connect();
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();
    }

}

