package com.gzlh.device.electron.handler.impl;

import cn.hutool.core.util.StrUtil;
import com.gzlh.device.electron.brand.ElectronBrandType;
import com.gzlh.device.electron.client.ElectronNettyConfig;
import com.gzlh.device.electron.handler.IElectronHandler;
import com.gzlh.device.electron.utils.CheckNumUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * 瑞德电子车牌处理类
 */
@Component
@Slf4j
public class ElectronHandlerRuiDe implements IElectronHandler {
    private final String CALL_BACK_HEADER="F0";

    @Resource
    private ElectronNettyConfig electronNettyConfig;
    @Override
    public ElectronBrandType brandType() {
        return ElectronBrandType.RUI_BRAND;
    }

    @Override
    public void handlerAction(String action) {

    }

    @Override
    public void sendMsg(String msg) {
        electronNettyConfig.send(msg);
    }

    @Override
    public void handlerMsg(String msg) {
        int len=msg.length();
        //引导码
        String bootCode=StrUtil.sub(msg,0,2);
        if (StrUtil.equals(bootCode,CALL_BACK_HEADER)){
            //长度
            String lenHex=StrUtil.sub(msg,2,4);
            //命令Command
            String command=StrUtil.sub(msg,4,6);
            //return data，返回的数据
            String data= StrUtil.sub(msg,0,len-2);
            //校验码
           String checkNum= StrUtil.sub(msg,len-2,len);
           //计算出来的校验码
           String num=  CheckNumUtils.calculateChecksum(data);
           if (!StrUtil.equals(checkNum,num)){
               return;
           }
        }
    }

}
