package com.gzlh.device.infrared.client;

import cn.hutool.core.util.StrUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.gzlh.device.infrared.config.RedPropertiesConfig;
import com.gzlh.device.infrared.factory.RedFactory;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ChannelHandler.Sharable
public class RedClientHandler extends SimpleChannelInboundHandler<String> {

    private RedNettyConfig redNettyConfig;

    public RedClientHandler(RedNettyConfig redNettyConfig) {
        this.redNettyConfig = redNettyConfig;
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
        log.info("红外客户端收到消息：" + msg);
        msg = StrUtil.replace(msg, "\u0003", "").replace("\u0002", "");
        log.info("转换后消息：" + msg);
        // 去掉开头和结尾的特殊字符
        RedPropertiesConfig propertiesConfig = SpringUtil.getBean(RedPropertiesConfig.class);
        RedFactory redFactory = SpringUtil.getBean(RedFactory.class);
        redFactory.handler(propertiesConfig.getBrand()).handlerMsg(msg);

    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        System.out.println("连接断开，进行重连");
        redNettyConfig.connect();
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();
    }

}

