package com.gzlh.device.led.handler.impl;

import cn.hutool.core.util.StrUtil;
import com.gzlh.bus.EventDataManager;
import com.gzlh.device.led.action.LedAction;
import com.gzlh.device.led.brand.LedBrandType;
import com.gzlh.device.led.client.LedNettyConfig;
import com.gzlh.device.led.handler.ILedHandler;
import com.gzlh.device.led.utils.FengLiYuanPackUtils;
import com.gzlh.device.led.utils.LedOptions;
import com.gzlh.entity.ReqBO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;

@Service
@Slf4j
public class LedHandlerFengLiYuan implements ILedHandler {
    @Resource
    LedNettyConfig ledNettyConfig;

    @Override
    public LedBrandType brandType() {
        return LedBrandType.FENGLIYUAN;
    }

    @Override
    public void sendMsg(String content, LedOptions options) {
        log.info("丰利源发送led消息:{}",content);
        String msgHex= FengLiYuanPackUtils.build(content,options);
        log.info("数据包:{}",msgHex);
        ledNettyConfig.send(msgHex);
    }

    @Override
    public void handlerAction(String action) {
        if (StrUtil.contains(action, LedAction.LED_SHOW_CONTENT)) {
            ReqBO reqBO = null;
            //展示内容
            if (StrUtil.contains(action,"platNo")){
                String carNo="";
                reqBO = EventDataManager.getCacheData();
                if (reqBO!=null){
                    if (!StringUtils.isEmpty(reqBO.getCarNo())) {
                        carNo = reqBO.getCarNo();
                    }
                }
                LedOptions ledOptions=new LedOptions();
                ledOptions.setColor("05").setLine("02").setShowType("0B");
                sendMsg(carNo,ledOptions);
            }else  if (StrUtil.contains(action,"weight")){
                String weight ="";
                reqBO = EventDataManager.getCacheData();
                if (reqBO!=null){
                    if (reqBO.getWeight()!=null) {
                        weight= String.format("%.0f", EventDataManager.getCacheData().getWeight());
                    }
                }
                LedOptions ledOptions=new LedOptions();
                ledOptions.setColor("04").setLine("03").setShowType("0B");
                sendMsg(weight,ledOptions);
            }else{
                String content = action.substring(action.indexOf("(")+1, action.indexOf(")"));
                LedOptions ledOptions=new LedOptions();
                ledOptions.setColor("03").setLine("04").setShowType("00");
                sendMsg(content,ledOptions);
            }
        }
    }
}
