package com.gzlh.device.led.handler.impl;

import cn.hutool.core.util.StrUtil;
import com.gzlh.bus.EventConfig;
import com.gzlh.bus.EventDataManager;
import com.gzlh.device.led.action.LedAction;
import com.gzlh.device.led.brand.LedBrandType;
import com.gzlh.device.led.client.LedNettyConfig;
import com.gzlh.device.led.handler.ILedHandler;
import com.gzlh.device.led.utils.ColorConver;
import com.gzlh.device.led.utils.LedOptions;
import com.gzlh.device.led.utils.YangBandPackage;
import com.gzlh.device.infrared.brand.RedBrandType;
import com.gzlh.utils.WordHandlerUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * 上海仰邦科技股份有限公司BX-5(M)K/6K（YY）-V4.2 led发送处理器
 */
@Service
@Slf4j
public class LedHandlerYangBandV4d2 implements ILedHandler {

    @Resource
    private LedNettyConfig ledNettyConfig;

    @Override
    public LedBrandType brandType() {
        return LedBrandType.SHANGHAI_YANGBAND_BX;
    }

    @Override
    public void sendMsg(String content, LedOptions ledOptions) {
        log.info(RedBrandType.SHANGHAI_YANGBAND_BX.getBrand() + "发送消息:{}", content);
        String pack = YangBandPackage.buildPackage(ColorConver.NU_TO_HEX.get(1) + WordHandlerUtils.msgToASCII(content));
        log.info(RedBrandType.SHANGHAI_YANGBAND_BX.getBrand() + "转换后的数据：{}", pack);
        ledNettyConfig.send(pack);
    }

    /**
     * 特殊站位符 ${platNo}
     * @param action
     */
    @Override
    public void handlerAction(String action) {

        log.info("action:{}",action);
    }
}
