package com.gzlh.device.led.utils;

public class YangBandPackage {
    /**
     * 帧头
     */
    private static final String HEAD = "a5 a5 a5 a5 a5 a5 a5 a5";
    /**
     * 帧尾
     */
    private static final String EXT = "5a";


    public static String buildPackage(String dataView) {
        //包头数据= 前部分+数据域长度（两字节长度）
        //数据包=帧头+包头数据+数据域+校验包+帧尾；
        //包头数据=led工作模式+数据域长度（两位）
        //数据域=显示域+数据域长度+数据设置
        //包校验=包头数据+数据域的 CRC16校验
        String packPrefix = "01 00 00 80 00 00 00 00 00 01 51 02";
        String dataPrefix = "a3 06 01 00 00 00 01";
        String dataCmd = "06 00 00 00 00 0C 00 20 00 00 00 00 02 00 00 00 00 01 01 01 00 00 0a";
        String len = Integer.toHexString(dataView.replaceAll(" ", "").length() / 2);
        String dataLen = (len.length() == 1 ? "0" + len : len) + " 00 00 00";
        String dataSetting = dataCmd + dataLen + dataView;
        len = Integer.toHexString(dataSetting.replaceAll(" ", "").length() / 2);
        String areaDataLen = (len.length() == 1 ? "0" + len : len) + " 00";
        //数据域
        String dataStr = dataPrefix + areaDataLen + dataCmd + dataLen + dataView;
        len = Integer.toHexString(dataStr.replaceAll(" ", "").length() / 2);
        String packLen = (len.length() == 1 ? "0" + len : len) + " 00";
        String packData = packPrefix + packLen + dataStr;
        packData = packData.replaceAll(" ", "");
        int[] a = new int[packData.length() / 2];
        for (int i = 0; i < packData.length(); i += 2) {
            a[i / 2] = Integer.parseInt(packData.substring(i, i + 2), 16);
        }
        String crc16 = CRC16.crc16(a, a.length);
        String str= (HEAD + packData + crc16 + EXT).replaceAll(" ", "")
                .toLowerCase();
        return str.replaceAll("(?<=\\G..)(?!$)", " ");
    }
}
