package com.gzlh.device.weighbridge.handler.impl;

import cn.hutool.core.util.StrUtil;
import com.gzlh.device.weighbridge.action.WeighbridgeCommonAction;
import com.gzlh.device.weighbridge.brand.WeighbridgeBrandType;
import com.gzlh.device.weighbridge.handler.IWeighbridgeHandler;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * 宁波柯力地磅处理器
 */
@Service
@Slf4j
public class WeighbridgeHandlerKeDaKD8137 implements IWeighbridgeHandler {

    @Override
    public WeighbridgeBrandType brandType() {
        return WeighbridgeBrandType.KEDA_KD_8137;
    }


    @Override
    public void handlerMsg(String msg) {
        log.info(WeighbridgeBrandType.KEDA_KD_8137.getBrand() + "地磅:{}", msg);
        //处理后的磅数
        int weight = parseWeight(msg);
        CommonWeighbridgeHandler.cacheWeight(weight);
    }


    @Override
    public void handlerAction(String actionCommand) {
        actionCommand = actionCommand.toUpperCase();
        if (StrUtil.equals(actionCommand, WeighbridgeCommonAction.START_READ)) {
            //开始读取地磅数据
            CommonWeighbridgeHandler.startToRead();

        }
    }

    /**
     * 解析地磅数据
     *
     * @param msg
     * @return
     */
    private int parseWeight(String msg) {
        return 0;
    }

}
