package com.gzlh.utils;

public class ModbusUtils {
    public static String buildRequestPacket(String packData) {
        int[] a = new int[packData.length() / 2];
        for (int i = 0; i < packData.length(); i += 2) {
            a[i / 2] = Integer.parseInt(packData.substring(i, i + 2), 16);
        }
        int crc = calculateCRC(a);
       return packData+String.format("%04X",crc);
    }
    private static int swapBytes(int value) {
        int highByte = (value >> 8) & 0xFF; // 获取高字节
        int lowByte = value & 0xFF; // 获取低字节

        return (lowByte << 8) | highByte; // 交换高低字节位置
    }
    public static int calculateCRC(int[] data) {
        int crc = 0xFFFF;

        for (int b : data) {
            crc ^= (int) b & 0xFF;
            for (int i = 0; i < 8; i++) {
                if ((crc & 0x0001) != 0) {
                    crc >>= 1;
                    crc ^= 0xA001;
                } else {
                    crc >>= 1;
                }
            }
        }

        return swapBytes(crc);
    }

    public static void main(String[] args) {
        String packData = "01050000FF00";
        System.out.println(buildRequestPacket(packData));
        String s="F5,01,00,33,01,01,00,01,00,01,00,01,08,BB,B6,D3,AD,B9,E2,C1,D9,02,00,00,00,01,1C,C9,EE,DB,DA,CA,D0,5B,40,32,5D,B7,E1,C0,FB,D4,B4,5B,40,33,5D,D3,D0,CF,DE,B9,AB,CB,BE,A4";
        System.out.println(s.replaceAll(",",""));
        String sr="010100010001000108BBB6D3ADB9E2C1D902000000011CC9EEDBDACAD05B40325DB7E1C0FBD4B45B40335DD3D0CFDEB9ABCBBE";
        System.out.println(sr.length());
    }
}
